local Base=require 'game/base'
local bulletimg=love.graphics.newImage("images/shoot.png")

local BULLETS={}

local N=class(Base, function(self, startx, starty, dir)
  Base.init(self)
  self.x=startx
  self.y=starty
  self.dir=dir
  self.distance=0
end)

function N:getPosition()
  local x=self.x+self.distance*self.dir
  local y=self.y-179
  return x,y
end

function N:draw()
  local x=self.x+self.distance*self.dir
  local y=self.y
	love.graphics.draw(bulletimg,x,y-65)
  
  if DEBUG then
    love.graphics.setLineWidth(2)
    love.graphics.setColor(255,0,0,255)
    love.graphics.circle('fill', x,y,10,10)
    love.graphics.setColor(0, 255, 255,255)
    love.graphics.circle('fill', x, y, 5, 10)
    love.graphics.setColor(255,255,255,255)
  end
  
end

function N:__tostring()
  local x,y=self:getPosition()
  return '<Bullet x='..x..' y='..y..'>'
end

local Bullet=N


local M=class(Base, function(self)
  Base.init(self)
end)

function M:FireBullet()
  print('FIRE BULLET')
  TEsound.play("audio/shotgun.wav","soundeffects")
  local player=Game.Player
  local bullet=Bullet(player.x,player.y,player.dir)
  table.insert(BULLETS, bullet)
  self:add(bullet)
end

function M:FireShotGun()
	--will get working in a bit
end

function M:update(dt)
  for k=#BULLETS, 1, -1 do
    local v=BULLETS[k]
    v.x=v.x+v.dir*2
    v.distance=v.distance+2
    local levelWidth=Game.Level.width
    if v.x<0 or v.x>levelWidth or v.distance>=500 then
      print('bullet on limit - remove', v.x)
      self:removeBullet(v)
    end
  end
end

function M:keypressed(a, b)
  if a==' ' and #BULLETS<=2 then
    self:FireBullet()
	end
end

function M:mousepressed(x, y, b)
	if b=="l" and #BULLETS<=2 then
    self:FireBullet()
	end
end

function M:getBullets()
  return BULLETS
end

function M:removeBullet(b)
  for k,v in ipairs(BULLETS) do
    if v==b then
      table.remove(BULLETS, k)
    end
  end
  self:remove(b)
end

function M:__tostring()
  return '<Bullets>'
end

return M
