local Base=require 'game/base'

local ITEMS={}

local M=class(Base, function(self)
  Base.init(self)
end)

function M:add(image, x, y, collide, removeOnCollide, func)
	if image and x and y then table.insert(ITEMS, {img = love.graphics.newImage(image),x = x, y = y, collide = collide, removeOnCollide = removeOnCollide, func = func,}) end
end

function M:draw()
  local dx, dy
  local player=Game.Player
	for i,v in ipairs(ITEMS) do
		dx = (player.x) - (v.x)
		dy = (player.y) - (v.y )
		local dist = math.sqrt ( dx^2 + dy^2 )		
		
    love.graphics.draw(v.img, v.x,v.y,0,1,1,v.img:getWidth()/2,v.img:getHeight()/2)

		if v.collide and dist < 30 then
			v.func(i,v)
			if v.removeOnCollide then
				table.remove(ITEMS, i)
			end
		end
    if DEBUG then
      love.graphics.setLineWidth(2)
      love.graphics.setColor(255,0,0,255)
      local ix,iy=v.img:getWidth()/2,v.img:getHeight()/2
      love.graphics.rectangle('line', v.x-ix, v.y-iy, 2*ix, 2*iy)
      love.graphics.circle('fill', v.x, v.y, 10, 10)
      love.graphics.setColor(0,255,255,255)
      love.graphics.circle('fill', v.x, v.y, 5, 10)
      love.graphics.setColor(255,255,255,255)
    end
	end
end

function M:__tostring()
  return '<Items>'
end

return M
