local Base=require 'game/base'
local Mobs=require 'game/Mobs'
local Items=require 'game/Items'
local Bullets=require 'game/Bullets'

local M=class(Base, function(self, nr, img)
  Base.init(self)
  self.level=nr
  self.img=love.graphics.newImage(img)
  self.width=self.img:getWidth()
  self.camX=0
  self.Mobs=Mobs()

  self.Bullets=Bullets()
  self.Items=Items()

  
end)

function M:load()
  self:add(self.Items)
  self:add(self.Mobs)
  self.Mobs:add(400,555,90+math.random(20))
  self.Mobs:add(400,758,90+math.random(20))
  
  self:add(Game.Player)
  Game.Player:setCurrentLevel(self)
  self:add(self.Bullets)
  
  local tempFunc = function(i,v)
  potreg=700
	end

	for i = 1,5 do
			self.Items:add("images/health.png",  math.random(200,3300), math.random(500,580), true,true, tempFunc)
	end

end

function M:draw()
  cam:predraw()
  love.graphics.draw(self.img, 0, 0)
  Base.draw(self)
  cam:postdraw()
  if DEBUG then
    love.graphics.print(string.format("Camera X=%d Scores=%d", self.camX, Game.Player.score), 10, 10)
  end
end

function M:update(dt)
  local player=Game.Player
  local camX
	if player.x <= love.graphics.getWidth()/2 then
		camX = love.graphics.getWidth()/2
	elseif player.x >= self.width - love.graphics.getWidth()/2 then
		camX = self.width - love.graphics.getWidth()/2
	else
		camX = player.x
	end
	cam:setPos(vector(camX,love.graphics.getHeight()/2))
  self.camX=camX
  Base.update(self, dt)
end

function M:__tostring()
  return '<Level '..self.level..' camX='..self.camX..'>'
end
  
return M

