local Base=require 'game/base'

local M=class(Base, function(self, x, y, speed)
  Base.init(self)
  self.x=x
  self.y=y
  self.animation=newAnimation(love.graphics.newImage("images/playerr.png"), 119, 227, 0.07+((speed/10000)*2), 0)
  self.speed = speed
  self.health=3
end)
	
function M:draw(state)
  local player=Game.Player
	local dt = love.timer.getDelta()
  local dx = (player.x - self.x)
  local dy = (player.y - self.y)
  local dist = math.sqrt ( dx^2 + dy^2 )
  if dx<0 then
    self.animation:draw(self.x, self.y, 0, -1, 1, 50, 179)
  else
    self.animation:draw(self.x, self.y, 0, 1, 1, 50, 179)
  end
  if DEBUG then
    love.graphics.setLineWidth(2)
    love.graphics.setColor(255,0,0,255)
    love.graphics.rectangle('line', self.x-50, self.y-179, 119, 227)
    love.graphics.circle('fill', self.x, self.y, 10, 10)
    love.graphics.setColor(0, 255, 255,255)
    love.graphics.circle('fill', self.x, self.y, 5, 10)
    love.graphics.setColor(255,255,255,255)
  end

end

function M:update(dt)
  local player=Game.Player
	local dt = love.timer.getDelta()

  local dx = (player.x - self.x)
  local dy = (player.y - self.y)
  local dist = math.sqrt ( dx^2 + dy^2 )
  if dist <=10 then
		player.health=player.health-0.5-((math.random()*2))
		self.x=self.x-11
  end


  if dist >= 10 then
    self.animation:update(dt)
    self.x = self.x + dx / dist * (dt * self.speed)
    self.y = self.y + dy / dist * (dt * self.speed)
	end

  -- check for bullet
  local bullets = Game.Level.Bullets
  
  for idx, bullet in ipairs(bullets:getBullets()) do
    local bx,by=bullet:getPosition()
    dx = (self.x - bx)
    dy = (self.y-179 - by)
    dist = math.sqrt ( dx^2 + dy^2 )
    if dist<=50 then
      self:onHit(bullet)
    end
  end
end

function M:onHit(bullet)
  self.health=self.health-1
  local bullets = Game.Level.Bullets
  bullets:removeBullet(bullet)
  if self.health<=0 then
    print('REMOVE MOB')
    Game.Level.Mobs:remove(self)
    Game.Level.Mobs:addRandom()
    Game.Player:increaseScore(1)
  end
end

function M:__tostring()
  return '<Mob x,y='..self.x..','..self.y..' speed='..self.speed..'>'
end

return M
