local Base=require 'game/base'

local M=class(Base, function(self)
  Base.init(self)
	self.health=100
	self.dir=1
	self.run=0
	self.x=100
	self.y=490
	self.offsetX=0
	self.moveDistance = 200
	self.img = love.graphics.newImage("images/player.png")
	self.currentLevel = 1
	self.coins = 0
	self.anim = newAnimation(self.img, 119, 227, 0.07, 6)
  self.score=0
end)

function M:setCurrentLevel(lvl)
  self.currentLevel=lvl
  return self
end

function M:increaseScore(points)
  self.score=self.score+points
end

function M:update(dt)
  if self.health<=0 then
    love.event.push('q')
  end
  
  self.run=false
  
  if love.keyboard.isDown("left") then
		self.x = self.x - self.moveDistance * dt	
		self.dir = (-1)
		self.offsetX = 0
    self.run=true
    if self.x<0 then self.x=0 end
  end
	
  if love.keyboard.isDown("right") then
		self.x = self.x + self.moveDistance * dt	
		self.dir = (1)
		self.offsetX = 100
    self.run=true
    if self.x>self.currentLevel.width then self.x=self.currentLevel.width end
  end
	
  if love.keyboard.isDown("up") then
		if self.y>460 then
			self.y = self.y - self.moveDistance * dt
		end
    self.run=true
	end

  if love.keyboard.isDown("down") then
		if self.y<649 then
			self.y = self.y + self.moveDistance * dt
		end
		
    if love.keyboard.isDown("u") then
      Game.Level.Mobs:remove(1)
		end
    self.run=true
	end
		
	self.anim:update(dt)
end

function M:draw()
	self.anim:draw(self.x, self.y, 0, self.dir, 1, 50, 179)
  if DEBUG then
    love.graphics.setLineWidth(2)
    love.graphics.setColor(255,0,0,255)
    love.graphics.rectangle('line', self.x-50, self.y-179, 119, 227)
    love.graphics.circle('fill', self.x, self.y, 10, 10)
    love.graphics.setColor(0, 255, 255,255)
    love.graphics.circle('fill', self.x, self.y, 5, 10)
    love.graphics.setColor(255,255,255,255)
  end
end

function M:__tostring()
  return '<Player pos='..self.x..','..self.y..'>'
end

return M
